package org.hardknockjava.lesson15.record;

/****************************************************************
 * SortControl describes a Field with a @Key annotation, 
 * on which a BaseRecord will be sorted. Once determined,
 * the SortControls are sorted in order by sortOrder.
 */

import java.lang.reflect.Field;

public class SortControl implements Comparable<SortControl> {
    private Field sortField;
    private int sortOrder;
    private SequenceType sequence;

    public SortControl(Field sortField, int sortOrder, SequenceType sequence) {
        super();
        this.sortField = sortField;
        this.sortOrder = sortOrder;
        this.sequence = sequence;
    }

    public Field getSortField() {
        return sortField;
    }

    public int getSortOrder() {
        return sortOrder;
    }
    
    public SequenceType getSequence() {
        return sequence;
    }

    // Provide the natural sort order for this class.
    @Override
    public int compareTo(SortControl o) {
        return this.sortOrder - o.sortOrder;
    }
}
